# Written by Mads Engelund, 2017, http://espeem.com
import unittest

from CalcTroll.ASEUtils.Atoms import Atoms
from CalcTroll.Core.Test.Case import CalcTrollTestCase
from CalcTroll.API import view

from .TerminatedRibbon import TerminatedArmchairRibbon, TerminatedZigzagRibbon


class TerminatedRibbonTest(CalcTrollTestCase):
    def notestArmchairConstruction(self):
        parameters = dict(free_layers=6, bound_layers=6)
        ribbon = TerminatedArmchairRibbon(n=7, parameters=parameters)
        atoms = ribbon.atoms()

        expected = [[ 0. , -2.45951215, -8.19      ],
                    [ 0. ,  0.        , -8.19      ],
                    [ 0. ,  2.45951215, -8.19      ],
                    [ 0. , -2.45951215, -7.1       ],
                    [ 0. ,  0.        , -7.1       ],
                    [ 0. ,  2.45951215, -7.1       ],
                    [ 0. , -4.63323591, -6.935     ],
                    [ 0. ,  4.63323591, -6.935     ],
                    [ 0. , -3.68926822, -6.39      ],
                    [ 0. , -1.22975607, -6.39      ],
                    [ 0. ,  1.22975607, -6.39      ],
                    [ 0. ,  3.68926822, -6.39      ],
                    [ 0. , -3.68926822, -4.97      ],
                    [ 0. , -1.22975607, -4.97      ],
                    [ 0. ,  1.22975607, -4.97      ],
                    [ 0. ,  3.68926822, -4.97      ],
                    [ 0. , -4.63323591, -4.425     ],
                    [ 0. ,  4.63323591, -4.425     ],
                    [ 0. , -2.45951215, -4.26      ],
                    [ 0. ,  0.        , -4.26      ],
                    [ 0. ,  2.45951215, -4.26      ],
                    [ 0. , -2.45951215, -2.84      ],
                    [ 0. ,  0.        , -2.84      ],
                    [ 0. ,  2.45951215, -2.84      ],
                    [ 0. , -4.63323591, -2.675     ],
                    [ 0. ,  4.63323591, -2.675     ],
                    [ 0. , -3.68926822, -2.13      ],
                    [ 0. , -1.22975607, -2.13      ],
                    [ 0. ,  1.22975607, -2.13      ],
                    [ 0. ,  3.68926822, -2.13      ],
                    [ 0. , -3.68926822, -0.71      ],
                    [ 0. , -1.22975607, -0.71      ],
                    [ 0. ,  1.22975607, -0.71      ],
                    [ 0. ,  3.68926822, -0.71      ],
                    [ 0. , -4.63323591, -0.165     ],
                    [ 0. ,  4.63323591, -0.165     ],
                    [ 0. , -2.45951215,  0.        ],
                    [ 0. ,  0.        ,  0.        ],
                    [ 0. ,  2.45951215,  0.        ],
                    [ 0. , -2.45951215,  1.09      ],
                    [ 0. ,  0.        ,  1.09      ],
                    [ 0. ,  2.45951215,  1.09      ]]

        e_atoms = Atoms('H3C3H2C8H2C6H2C8H2C3H3', positions=expected)
        self.assertAtomsEqual(e_atoms, atoms)

    def notestZigZagConstruction(self):
        parameters = dict(bound_layers=3, free_layers=2)
        ribbon = TerminatedZigzagRibbon(n=6, parameters=parameters)
        atoms = ribbon.atoms()

        expected = [[ 0. ,  -4.97  , -6.00902429],
                    [ 0. ,  -3.55  , -6.00902429],
                    [ 0. ,  -0.71  , -6.00902429],
                    [ 0. ,   0.71  , -6.00902429],
                    [ 0. ,   3.55  , -6.00902429],
                    [ 0. ,   4.97  , -6.00902429],
                    [ 0. ,  -4.97  , -4.91902429],
                    [ 0. ,  -3.55  , -4.91902429],
                    [ 0. ,  -0.71  , -4.91902429],
                    [ 0. ,   0.71  , -4.91902429],
                    [ 0. ,   3.55  , -4.91902429],
                    [ 0. ,   4.97  , -4.91902429],
                    [ 0. ,  -6.77  , -3.68926822],
                    [ 0. ,  -5.68  , -3.68926822],
                    [ 0. ,  -2.84  , -3.68926822],
                    [ 0. ,  -1.42  , -3.68926822],
                    [ 0. ,   1.42  , -3.68926822],
                    [ 0. ,   2.84  , -3.68926822],
                    [ 0. ,   5.68  , -3.68926822],
                    [ 0. ,   6.77  , -3.68926822],
                    [ 0. ,  -4.97  , -2.45951215],
                    [ 0. ,  -3.55  , -2.45951215],
                    [ 0. ,  -0.71  , -2.45951215],
                    [ 0. ,   0.71  , -2.45951215],
                    [ 0. ,   3.55  , -2.45951215],
                    [ 0. ,   4.97  , -2.45951215],
                    [ 0. ,  -6.77  , -1.22975607],
                    [ 0. ,  -5.68  , -1.22975607],
                    [ 0. ,  -2.84  , -1.22975607],
                    [ 0. ,  -1.42  , -1.22975607],
                    [ 0. ,   1.42  , -1.22975607],
                    [ 0. ,   2.84  , -1.22975607],
                    [ 0. ,   5.68  , -1.22975607],
                    [ 0. ,   6.77  , -1.22975607],
                    [ 0. ,  -4.97  ,  0.        ],
                    [ 0. ,  -3.55  ,  0.        ],
                    [ 0. ,  -0.71  ,  0.        ],
                    [ 0. ,   0.71  ,  0.        ],
                    [ 0. ,   3.55  ,  0.        ],
                    [ 0. ,   4.97  ,  0.        ],
                    [ 0. ,  -4.97  ,  1.09      ],
                    [ 0. ,  -3.55  ,  1.09      ],
                    [ 0. ,  -0.71  ,  1.09      ],
                    [ 0. ,   0.71  ,  1.09      ],
                    [ 0. ,   3.55  ,  1.09      ],
                    [ 0. ,   4.97  ,  1.09      ]]

        e_atoms = Atoms('H6C6HC6HC6HC6HC6H6', positions=expected)
        self.assertAtomsEqual(e_atoms, atoms)


if __name__=='__main__':
    unittest.main()
